from logic import *


class GeneralizingAgent:
    '''
    Yours task is to implement this class which should behave as generalizing algorithm from the lecture.

    Firstly, the agent is initialized with the most specific CNF generated from given st-range restriction constrains; that is his hypothesis.
    When the agent gets a sample (.feedSample(Sample)), it should get his hypothesis consistent with the sample using only polynomial steps.

    The agent may be asked, by method getCNF(), to give his current hypothesis out.

    You may find useful some methods in tools, e.g. literalsToCanonics which converts list of literlas to set of their canonical strings.

    '''
    def __init__(self, cnf):
        '''
        Construct the agent with a hypothesis.

        :type cnf:
        :rtype: GeneralizingAgent
        '''
        self.cnf = cnf

    def feedSample(self, sample):
        '''
        After receiving the sample, agent should get his hypothesis consistent to this sample/observation.

        :type sample: Sample
        :rtype: None
        '''
        ...
        # your code here
        pass

    def getCNF(self):
        '''
        Returns agent hypothesis (a CNF).

        :rtype: CNF
        '''
        return self.cnf


