import functools


def unionSets(collectionOfSet):
    '''
    Taking set of set, this method makes one big set by union of all the set given

    :type setOfSet: set(set())
    :rtype: set
    '''
    collectionOfSet = list(collectionOfSet)
    if len(collectionOfSet) < 1:
        return set()
    return set(functools.reduce((lambda x, y: x.union(y)), collectionOfSet))


def replaceWithFreshVariables(clause, variableFactory):
    '''
    Returns a copy of the given clause containing fresh new variables.

    :type clause: Clause
    :type variableFactory: VariableFactory
    :rtype: Clause
    '''
    substitution = {}
    for variable in clause.getVariables():
        substitution[variable] = variableFactory.create()
    return clause.substitute(substitution)

def literalsToCanonics(literals):
    '''
    Converts the set of literals to set of their canonical strings.

    :type literals: Set(Literals)
    :rtype: Set(String)
    '''
    return set(map(lambda literal: str(literal.atom), literals))
